diff --git a/.gitignore b/.gitignore
index d5584f31fee5ff6b3594b3dbdad5d98091ae862e..bd6bc54de456d089985787123ab09f8976bbdf42 100644
--- a/.gitignore
+++ b/.gitignore
@@ -1,5 +1,6 @@
 *.tgz
 .*.swp
 
+_build
 lib
 node_modules
diff --git a/LICENSE b/LICENSE
new file mode 100644
index 0000000000000000000000000000000000000000..545d4dd1d3b0c720c40284ccaae4f75b607d62c9

--- /dev/null
+++ b/LICENSE
@@ -0,0 +1,19 @@
+Copyright (c) 2014-2025 Beanbag, Inc.
+
+Permission is hereby granted, free of charge, to any person obtaining a copy of
+this software and associated documentation files (the "Software"), to deal in
+the Software without restriction, including without limitation the rights to
+use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
+of the Software, and to permit persons to whom the Software is furnished to do
+so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in all
+copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+SOFTWARE.
diff --git a/eslint.config.mjs b/eslint.config.mjs
new file mode 100644
index 0000000000000000000000000000000000000000..c8f0b4e019669f0aa229944f10e83b439f6ff2e6

--- /dev/null
+++ b/eslint.config.mjs
@@ -0,0 +1,32 @@
+import path from 'node:path';
+import { fileURLToPath } from 'node:url';
+
+import { FlatCompat } from '@eslint/eslintrc';
+import js from '@eslint/js';
+import { defineConfig } from 'eslint/config';
+import globals from 'globals';
+
+import beanbag from '@beanbag/eslint-plugin';
+
+
+const __filename = fileURLToPath(import.meta.url);
+const __dirname = path.dirname(__filename);
+const compat = new FlatCompat({
+    allConfig: js.configs.all,
+    baseDirectory: __dirname,
+    recommendedConfig: js.configs.recommended,
+});
+
+export default defineConfig([{
+    extends: compat.extends('plugin:@beanbag/recommended'),
+
+    plugins: {
+        '@beanbag': beanbag,
+    },
+
+    languageOptions: {
+        globals: {
+            ...globals.node,
+        },
+    },
+}]);
diff --git a/rollup.config.js b/rollup.config.js
index 9721c21c312271f0ef2227843608d7c98d468162..8fde6ba9e4f3b167305ed245c6ba932fa672c210 100644
--- a/rollup.config.js
+++ b/rollup.config.js
@@ -1,42 +1,72 @@
 import babel from '@rollup/plugin-babel';
 import resolve from '@rollup/plugin-node-resolve';
+import dts from 'rollup-plugin-dts';
+import externalGlobals from 'rollup-plugin-external-globals';
+
+
+const extensions = ['.ts'];
+const globalsMap = {
+    'jasmine-core': 'globalThis',
+};
 
 
 export default [
     {
         external: [
-            'jasmine',
+            'jasmine-core',
         ],
-        input: './src/index.js',
+        input: './src/index.ts',
         output: [
             {
-                file: `lib/index.js`,
+                esModule: false,
+                exports: 'named',
+                file: 'lib/index.js',
                 format: 'umd',
+                globals: globalsMap,
                 name: 'JasmineSuites',
-                esModule: false,
-                exports: 'named',
                 sourcemap: true,
             },
             {
                 dir: 'lib/esm',
+                exports: 'named',
                 format: 'esm',
-                exports: 'named',
+                globals: globalsMap,
                 sourcemap: true,
             },
             {
                 dir: 'lib/cjs',
+                exports: 'named',
                 format: 'cjs',
-                exports: 'named',
+                globals: globalsMap,
                 sourcemap: true,
             },
         ],
         plugins: [
             babel({
                 babelHelpers: 'bundled',
+                extensions: extensions,
             }),
+            externalGlobals(globalsMap),
             resolve({
+                extensions: extensions,
                 modulePaths: [],
             }),
         ],
     },
+    {
+        input: './_build/dts/index.d.ts',
+        output: [
+            {
+                'file': 'lib/index.d.ts',
+                'format': 'es',
+            },
+            {
+                'file': 'lib/index.d.mts',
+                'format': 'es',
+            },
+        ],
+        plugins: [
+            dts.default(),
+        ],
+    },
 ];
diff --git a/src/index.ts b/src/index.ts
new file mode 100644
index 0000000000000000000000000000000000000000..e99cd9af73a97757bb04a298275b3dc95a063feb

--- /dev/null
+++ b/src/index.ts
@@ -0,0 +1,234 @@
+/**
+ * Jasmine Suites.
+ *
+ * This offers namespaced test suites for Jasmine.
+ */
+
+import {
+    Suite,
+    describe,
+    jasmine,
+} from 'jasmine-core';
+
+
+/**
+ * Information on a suite of tests.
+ *
+ * This is a fancy generator for Jasmine describe() calls, which allows for
+ * taking a '/'-separated namespace of names and generating nested test suites.
+ *
+ * Subsequent calls that reuse any of these paths will have their tests added
+ * to the suite. This makes it very easy to organize tests, making it much
+ * easier to run subsets of tests across many files.
+ */
+class SuiteInfo {
+    /** The description for the suite. */
+    description: string | undefined;
+
+    /** The specs which are part of this suite. */
+    specs: (() => void) | null = null;
+
+    /** A mapping from name to each of the child suites. */
+    children: Record<string, SuiteInfo> = {};
+
+    /** The parent suite, if any. */
+    parentSuite: SuiteInfo | null = null;
+
+    /** The jasmine suite object that corresponds to this SuiteInfo. */
+    _suiteObj: Suite | null = null;
+
+    /** Whether specs have been added already. */
+    _added = false;
+
+    /*
+     * Construct the object.
+     *
+     * Args:
+     *     description (string, optional):
+     *         The description for the suite.
+     */
+    constructor(description?: string) {
+        this.description = description;
+    }
+
+    /**
+     * Return a SuiteInfo for a key, creating one if necessary.
+     *
+     * The SuiteInfo will be added to this suite's list of children.
+     *
+     * Args:
+     *     key (string):
+     *         The key for the suite.
+     *
+     *     description (string):
+     *         The description for the suite.
+     *
+     * Returns:
+     *     SuiteInfo:
+     *     The suite for the key.
+     */
+    getOrCreate(
+        key: string,
+        description: string,
+    ): SuiteInfo {
+        let suite = this.children[key];
+
+        if (!suite) {
+            suite = new SuiteInfo(description);
+            this.children[key] = suite;
+        }
+
+        return suite;
+    }
+
+    /**
+     * Add specs to this suite.
+     *
+     * The specs will either consist of a standard Jasmine specs function (if
+     * the caller sets suite.specs), or a set of internally-generated
+     * describe() calls.
+     */
+    _addSpecs() {
+        if (!this.specs) {
+            for (const value of Object.values(this.children)) {
+                value.describe(this);
+            }
+        } else if (!this._added) {
+            this.specs.call(this._suiteObj);
+        }
+    }
+
+    /**
+     * Run a describe() for the suite.
+     *
+     * This will run through the tree of specs/suites and generate the set of
+     * nested describe() calls. Each of these will be registered with Jasmine.
+     *
+     * The result will be a jasmine.Suite object.
+     */
+    describe(
+        parentSuiteInfo?: SuiteInfo,
+    ): SuiteInfo | null {
+        if (this._added) {
+            this._addSpecs();
+        } else {
+            describe(this.description, () => {
+                this._suiteObj = _curSuiteObj;
+                console.assert(this._suiteObj);
+
+                if (parentSuiteInfo) {
+                    const parentSuiteObj = parentSuiteInfo._suiteObj;
+                    const oldParentSuiteObj = _curSuiteObj.parentSuite;
+
+                    if (oldParentSuiteObj !== parentSuiteObj) {
+                        /*
+                         * Remove the suite object from the old parent. This
+                         * could potentially be slow, but in reality it's not
+                         * going to have a large search space for most suites.
+                         */
+                        const i = oldParentSuiteObj.children.indexOf(
+                            this._suiteObj);
+
+                        if (i !== -1) {
+                            oldParentSuiteObj.children.splice(i, 1);
+                        }
+
+                        /*
+                         * Add the suite to the new parent and fix relations.
+                         */
+                        parentSuiteObj.addChild(this._suiteObj);
+                        this._suiteObj.parentSuite = parentSuiteObj;
+
+                        /* Re-generate the full name of the suite. */
+                        this._suiteObj.result.fullName =
+                            this._suiteObj.getFullName();
+                    }
+                }
+
+                this._addSpecs();
+                this._added = true;
+            });
+        }
+
+        return this._suiteObj;
+    }
+}
+
+
+const _rootSuite = new SuiteInfo();
+let _curSuiteObj: Suite;
+
+
+/*
+ * We need access to the suite objects, which we can no longer get with 'this'
+ * above. So we need to monkey-patch the SuiteBuilder to capture this.
+ */
+const suiteBuilderProto = jasmine.SuiteBuilder.prototype;
+const _addSpecsToSuite = suiteBuilderProto.addSpecsToSuite_;
+
+suiteBuilderProto.addSpecsToSuite_ = function(
+    suite: Suite,
+    definitionFn: () => void,
+) {
+    _curSuiteObj = suite;
+
+    return _addSpecsToSuite.call(this, suite, definitionFn);
+};
+
+
+/**
+ * Define a test suite with a nested, reusable namespace.
+ *
+ * The namespace consists of a '/'-separated list of names that the provided
+ * specs of tests belong to. Each name in the list is equivalent to a
+ * Jasmine describe() call, nested in the spec for the previous name, with
+ * the exception these names can be reused across files.
+ *
+ * If more than one file has the same prefix for its namespace, those
+ * describe() suites will be reused. This makes it really easy to categorize
+ * tests under file paths, project names, or anything else, allowing those
+ * related tests to be run together.
+ *
+ * Args:
+ *     namespace (string):
+ *         The namespace for the suite.
+ *
+ *     specs (function):
+ *         The function which defines the test specs.
+ */
+export function suite(
+    namespace: string,
+    specs: () => void,
+) {
+    let parentSuite = _rootSuite;
+    let key = '';
+    let firstSuite: SuiteInfo | null = null;
+    let curSuite: SuiteInfo | null = null;
+
+    for (const description of namespace.split('/')) {
+        key += '/' + description;
+
+        curSuite = parentSuite.getOrCreate(key, description);
+        parentSuite = curSuite;
+
+        if (!firstSuite) {
+            firstSuite = curSuite;
+        }
+    }
+
+    /* The last suite is the one that'll run the provided test specs. */
+    if (!(curSuite instanceof SuiteInfo)) {
+        throw new Error('Current suite was not set');
+    }
+
+    curSuite.specs = specs;
+
+    if (!(firstSuite instanceof SuiteInfo)) {
+        throw new Error('firstSuite was not set');
+    }
+
+    return firstSuite.describe();
+}
+
+
+jasmine.getGlobal().suite = suite;
